<template>
  <div class="contract-tarification-container">
    <ObFunctionalPanel
      :columns="[]"
      :show-refresh="false"
      :show-edit="false"
      :show-group="false"
      :show-sort="false"
      :showColumnFilter="false"
      :showAddButton="isDraft"
      addButtonText="Добавить услугу"
      @add="onAddService"
      @search="onSearch"
    >
      <template v-if="listFilter" v-slot:extraFuncToPanel>
        <div class="contract-tarification-container-functional">
          <div class="contract-tarification-container__select-inline">
            <span>Показывать: </span>
            <ob-inline-select
              v-model="listFilter.uuid"
              :items="listFilters"
              :inherit-width="false"
            />
          </div>
        </div>
      </template>
    </ObFunctionalPanel>
    <div
      v-for="service in currentServiceList"
      :key="service.uuid"
      class="service-item"
    >
      <Accordeon
        :is-open="service.isOpened"
        :is-disabled="!listComponent(service)"
      >
        <div
          class="service-row"
          slot="title-content"
        >
          <div class="resource-type">
            <div class="resource-type__icon">
              <img src="./img/furgon.svg" alt="">
            </div>
            <div class="resource-type__desc">
              <div class="desc-title"><span>{{ service.serviceTypeTitle }}</span></div>
              <div
                v-if="service.resourceSpeciesTitle"
                class="desc-title"
              >
                <span>
                  {{ service.resourceSpeciesTitle }}. {{ service.resourceSubtypeTitle }} {{ service.resourcePatternParameter }}
                </span>
              </div>
              <div class="is-nds">Тарифы указаны {{ service.vatType !== 'NO_VAT' ? 'с учётом НДС' : 'без НДС' }}</div>
            </div>
          </div>
          <template v-if="caste === 'SIMPLE'">
            <div class="values-block --first">
              <div class="values-block__label">ЕД. изм.</div>
              <div class="values-block__value">{{ service.serviceUnitTitle }}</div>
            </div>
            <div class="values-block">
              <div class="values-block__label">допточка</div>
              <div class="values-block__value">{{ service.tariffs.extraPointTariff.priceWithVat / 100 | currency }} ₽</div>
            </div>
            <div class="values-block">
              <div class="values-block__label">допробег</div>
              <div class="values-block__value">{{ service.tariffs.extraMileageTariff.priceWithVat / 100 | currency }} ₽/км</div>
            </div>
            <div class="values-block">
              <div class="values-block__label">Направлений</div>
              <div class="values-block__value">{{ service.directionsCount }}</div>
            </div>
          </template>
          <template v-if="caste === 'ADDITIONAL'">
            <div class="values-block --first --geography">
              <div class="values-block__label">география</div>
              <div class="values-block__value">{{ serviceGeography[service.geography] }}</div>
            </div>
            <div class="values-block">
              <div class="values-block__label">ЕД. изм.</div>
              <div class="values-block__value">{{ service.serviceUnitTitle }}</div>
            </div>
            <div class="values-block">
              <div class="values-block__label">тариф</div>
              <div class="values-block__value">
                <template v-if="service.tariffs.tariff.priceWithVat">
                  {{ service.tariffs.tariff.priceWithVat / 100 | currency }} ₽
                </template>
                <template v-else>
                  —
                </template>
              </div>
            </div>
          </template>
          <ObMenuDropdown
            :items="getDropdownItems(service)"
            @click.native.stop
          />
        </div>
        <div>
          <component
            :is="listComponent(service)"
            :service="service"
            @on-update="getContractServices"
          />
        </div>
      </Accordeon>
    </div>
    <template slot="noneContent">
      <div class="title">
        <template v-if="caste === 'SIMPLE'">
          Здесь вы сможете настраивать тарифы для ваших<br/>перевозок. Для этого добавьте хотя бы одну услугу.
        </template>
        <template v-if="caste === 'ADDITIONAL'">
          <!--Здесь вы можете добавить и тарифицировать<br>дополнительные услуги-->
        </template>
        <template v-if="caste === 'MULTISTOP'">
          <!--Здесь вы сможете добавить и тарифицировать<br>мультистоповые услуги.-->
        </template>
      </div>
      <ObButton
        v-if="isDraft"
        label="Добавить услугу"
        type="flat"
        data-qa="addService"
        @click="onAddService"
      />
    </template>

    <component
      :is="currentServiceModal"
      ref="serviceModal"
      data-qa="tarificationService"
      :data-source="editedService"
      :title-second="titleSecondModal"
      :title="titleModal"
      @on-delete="deleteService"
      @submit="onSaveService"
      @copy="onCopyService"
    />
  </div>
</template>

<script>
  import { mapGetters } from 'vuex'
  import api from '@/api'
  import ObInlineSelect from 'common-components/src/obComponents/obInlineSelect'
  import ObSwitcher from "common-components/src/obComponents/obSwitcher"
  import ObTable from 'common-components/src/obComponents/obTable'
  import ObTabs from 'common-components/src/obComponents/obTabs'
  import ObButton from 'common-components/src/obComponents/obButton'
  import TransportationBaseServiceModal from '@/components/Contract/detail/services/TransportationBaseModal'
  import TransportationAdditionalModal from '@/components/Contract/detail/services/TransportationAdditionalModal'
  import TransportationMultistopModal from '@/components/Contract/detail/services/TransportationMultistopModal'
  import ContractDetailMixin from '@/components/Contract/detail/contract-detail-mixin'
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown'
  import ObFunctionalPanel from 'common-components/src/obComponents/obFuncPanel'
  import Accordeon from './accordeon'
  import Directions from './directionsNew'
  import Locations from './locationsNew'

  export default {
    name: 'ContractDetailTarification',
    mixins: [
      ContractDetailMixin
    ],
    components: {
      ObInlineSelect,
      ObSwitcher,
      ObTable,
      ObTabs,
      TransportationBaseServiceModal,
      TransportationAdditionalModal,
      TransportationMultistopModal,
      ObMenuDropdown,
      ObButton,
      ObFunctionalPanel,
      Accordeon,
    },
    data () {
      return {
        api,
        editedService: null,
        servicesList: [],
        listFilter: {
          uuid: 'all'
        },
        listFilters: [
          {
            uuid: 'all',
            title: 'Все'
          },
          {
            uuid: 'onlyWithDirections',
            title: 'Только с направлениями'
          }
        ],
        switcher: false,
      }
    },
    watch: {
      caste: {
        immediate: true,
        handler () {
          this.getContractServices()
        }
      }
    },
    computed: {
      ...mapGetters({
        isDraft: 'contract/isDraft',
        isVatPayer: 'contract/isDoerVatPayer'
      }),
      serviceGeography () {
        return {
          FROM_TO: 'Откуда-куда',
          WHERE: 'Где',
          WITHOUT_GEOGRAPHY_BINDING: 'Без привязки'
        }
      },
      currentServiceList () {
        const filters = {
          onlyWithDirections: (data) => data.directionsCount > 0,
          all: () => true
        }

        return this.servicesList.filter(data => filters[this.listFilter.uuid](data))
      },
      currentServiceModal () {
        const componentsMap = {
          SIMPLE: TransportationBaseServiceModal,
          ADDITIONAL: TransportationAdditionalModal,
          MULTISTOP: TransportationMultistopModal
        }

        return componentsMap[this.caste]
      },
      titleModal () {
        return this.editedService && this.caste !== 'MULTISTOP' ? this.getServiceTitle(this.editedService) : this.serviceTitleByType
      },
      serviceTitleByType () {
        let titleMap = {
          SIMPLE: 'Базовая услуга',
          MULTISTOP: 'Мультистоповая услуга',
          MULTIMODAL: 'Мультимодальная услуга',
          ADDITIONAL: 'Дополнительная услуга',
        }
        return titleMap[this.caste]
      },
      titleSecondModal () {
        if (this.editedService?.isSourceToCopy) {
          return null
        }
        if (!this.isDraft) {
          return 'Просмотр'
        }
        return this.editedService ? 'редактирование' : 'добавление'
      }
    },
    methods: {
      async getContractServices () {
        let res = await api.contract.getContractServices({
          uuid: this.$route.params.id,
          caste: this.caste
        })
        this.servicesList = res.content.map((service) => {
          const currentState = this.servicesList.find(current => service.uuid === current.uuid)?.isOpened || false
          return {
            ...service,
            type: this.caste,
            isOpened: currentState
          }
        })
      },
      onSearch (data) {
        console.log(data)
      },
      listComponent (service) {
        if (service.geography === 'FROM_TO') {
          return Directions
        } else if (service.geography === 'WHERE') {
          return Locations
        } else {
          return null
        }
      },
      async getServiceLocations (data) {
        const { uuid, geography } = data.item

        if (geography === 'FROM_TO') {
          return await api.contract.getServiceDirections({ uuid })
        } else if (geography === 'WHERE') {
          return await api.contract.getServiceLocations({ uuid })
        } else {
          return null
        }
      },
      getServiceTitle (object, isShort = false) {
        let {
          serviceTypeTitle,
          resourcePatternParameter,
          resourceSubtypeTitle,
          resourceSpeciesTitle,
          serviceUnitTitle,
          isSourceToCopy
        } = object || {}

        const serviceTitle = resourceSpeciesTitle ? `${serviceTypeTitle}. ${resourceSpeciesTitle}. ${resourceSubtypeTitle} ${resourcePatternParameter}. ${serviceUnitTitle}` : `${serviceTypeTitle}. ${serviceUnitTitle}`

        if (isSourceToCopy) {
          return 'Копирование базовой услуги'
        }

        if (isShort) {
          return serviceTitle
        }

        return `${this.serviceTitleByType} «${serviceTitle}»`
      },
      onAddService () {
        this.editedService = null
        this.$refs.serviceModal.open()
      },
      async editService ({ uuid, isVatInclude }) {
        try {
          let data = await api.contract.getServiceDetail({ uuid })
          this.editedService = {
            ...data,
            ...data.tariffs,
            isVatInclude,
            isNds: data.vatValue !== null,
            vatTypeUuid: 'b849dddf-63e1-4dc6-a00d-a9b7b3d15f53',
            uuid
          }
          this.$refs.serviceModal.open()
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: `Не удалось загрузить данные услуги`
          })
        }
      },
      onSelectService (data) {
        this.setEditedService({type: this.caste, ...data, serviceTitle: this.getServiceTitle(data, true)})
      },
      async deleteService ({ uuid, serviceCaste }) {
        this.$refs.serviceModal.close()
        try {
          await api.contract.deleteService({uuid, serviceCaste })
          this.$notification({
            type: 'system_notification_success',
            message: `Услуга удалена`
          })
          setTimeout(async () => {
            await this.getContractServices()
            this.calcExistServices({ data: this.contract })
          }, 2000)
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: `Ошибка удаления услуги`
          })
        }
      },
      async onSaveService ({ formData }) {
        let data = { ...formData }
        let isUpdate = Boolean(this.editedService && this.editedService.uuid)
        let serviceUuid

        try {
          if (isUpdate) {
            await this.updateService(data)
          } else {
            serviceUuid = await this.createService(data)
          }
          this.$notification({
            type: 'system_notification_success',
            message: `Услуга ${this.editedService ? 'обновлена' : 'добавлена'}`
          })
          this.$refs.serviceModal.close()
          this.setExistServices(true)
          setTimeout(async () => {
            await this.getContractServices()
            if (!isUpdate) {
              this.$nextTick(() => {
                this.servicesList.forEach(item => {
                  if (item.uuid === serviceUuid) {
                    item.isOpened = true
                  }
                })
              })
            }
          }, 2000)
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: `Ошибка ${this.editedService ? 'обновления' : 'добавления'} услуги`
          })
        }
      },
      async onCopyService ({ formData, sourceUuid }) {
        let data = { ...formData }

        try {
          await api.contract.copyService({ data, sourceUuid })
          this.$notification({
            type: 'system_notification_success',
            message: `Услуга успешно скопирована`
          })
          this.$refs.serviceModal.close()
          setTimeout(async () => {
            await this.getContractServices()
          }, 2000)
        } catch (e) {
          console.log(e)
          this.$notification({
            type: 'system_notification_error',
            message: `Ошибка копирования услуги`
          })
        }
      },
      async createService (data) {
        try {
          data.contractUuid = this.contract.uuid
          delete data.vatValue
          return await api.contract.createService({ data, serviceCaste: this.caste })
        } catch (e) {
          throw e
        }
      },

      async updateService (data) {
        data.serviceCaste = this.caste
        await api.contract.updateService({ data, uuid: this.editedService.uuid })

        setTimeout(() => {
          this.getContractServices()
        }, 1000)
      },
      getDropdownItems (data) {
        if (!this.isDraft) {
          return [
            {
              title: 'Просмотр услуги',
              method: () => this.editService(data)
            }
          ]
        }
        return [
          {
            title: 'Настроить услугу',
            icon: 'edit',
            method: () => this.editService(data)
          },
          {
            title: 'Копировать услугу с направлениями',
            icon: 'copy',
            method: () => this.copyService(data),
            isHidden: this.caste !== 'SIMPLE'
          },
          {
            title: 'Удалить услугу',
            icon: 'trash',
            className: 'menu-button-danger',
            method: () => this.deleteService(data)
          }
        ]
      },
      copyService (data) {
        this.editedService = { ...data, ...data.tariffs, isSourceToCopy: true }
        this.$refs.serviceModal.open()
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .contract-tarification-container {
    display: flex;
    flex-direction: column;
    height: 100%;

    &-functional {
      display: flex;
      align-items: center;
      flex: 1;
    }

    &__select-inline {
      padding: 7px 12px;
      margin-right: 12px;
      background: $lavender;
      border-radius: 19px;

      &.disabled {
        background: $color-white-lilac;
        pointer-events: none;
      }

      span {
        font-size: 14px;
        line-height: 18px;
        letter-spacing: 0.2px;
        color: $shale-gray;
      }

      &::v-deep {
        .ob-inline-select__label {
          margin-left: 4px;
          font-size: 14px;
          line-height: 18px;
        }
      }
    }

    &::v-deep {
      .ob-tabs__sliding-line {
        bottom: 0;
      }
      .ob-func-panel {
        padding-top: 1px;
        background-color: transparent;
        border-bottom: 1px $lavender solid;
      }
      .ob-func-panel__control {
        span {
          white-space: nowrap;
        }
      }

      .ob-func-panel__control {
        margin-right: 20px;
      }
    }

    .values-block {
      &__label {
        @include font-mixin(8.5px, 11px, 400, $color-grey-label, 0.4px, uppercase);
      }
      &__value {
        margin-top: 10px;
        @include font-mixin(14px, 16px, 400);
      }
    }

    .service-row {
      width: 100%;
      display: flex;
      align-items: center;
      justify-content: space-between;
      .values-block {
        width: 90px;
        margin-right: 20px;
        text-align: right;
        &.--first {
          width: 60px;
          text-align: left;
        }
        &.--geography {
          width: 100px;
        }
        &:last-of-type {
          margin-right: 30px;
        }
      }
      .resource-type {
        flex-grow: 2;
      }

      &::v-deep {
        .ob-menu-dropdown-container {
          margin-left: 25px;
        }
        .menu-button-danger {
          button {
            color: $color-error;
            .icon::before {
              color: $color-error!important;
            }
          }
        }
      }
    }

    .resource-type {
      display: flex;
      align-items: center;
      margin-right: 50px;
      &__icon {
        display: flex;
        align-items: center;
        justify-content: flex-end;
        width: 24px;
        margin-right: 40px;

        .icon {
          font-size: 16px;
          color: $color-grey-span;
        }
      }

      &__desc {
        .desc-title {
          @include font-mixin(14px, 18px, 400, $color-blue-navy-blue);
        }
        .is-nds {
          margin-top: 5px;
          @include font-mixin(12px, 18px, 400, $color-text-base);
        }
      }
    }
  }

  ::v-deep .ob-func-panel {
    &__controls {
      justify-content: flex-start;
      &-side {
        &:last-child {
          width: 100%;
          .ob-func-panel__control {
            &:first-child {
              width: 100%;
            }
          }
        }
      }
    }
  }

  .service-item + .service-item {
    margin-top: 1.5px;
  }
</style>
